# 机器学习仓库

## 1. 机器学习开源项目
* InsightFace  
	- 基于MXNet的人脸识别开源库 
	- https://github.com/deepinsight/insightface 
	- https://www.paperweekly.site/papers/1785 
* Augmentor  
	- Python图像增强库
	- https://github.com/mdbloice/Augmentor
* TextDistance  
	- 序列距离测算，包含 30+ 种算法的 Python 库，用于计算两个或多个序列之间的距离
	- https://github.com/orsinium/textdistance
* Neural Network Voices  
	- Siraj Raval 在 YouTube 上发布的神经网络语音合成教学视频对应代码，如何使用深度神经网络将普通人的声音转化为英国著名女演员 Kate Winslet 的声音。
	- https://github.com/llSourcell/Neural_Network_Voices
	- https://youtu.be/6KHSPiYlZ-U
* Personae  
	- 基于 TensorFlow 和 PyTorch 对深度强化学习、监督学习算法和论文进行实现，并尝试将其应用于金融市场（股市）。
	- https://github.com/ceruleanacg/Personae
* NNDial   
	- 一个用于构建端到端可训练任务型对话模型的开源工具包，本项目来自剑桥大学，使用的数据集为 CamRest676。
	- https://github.com/shawnwun/NNDIAL
* Voice Activity Detection Toolkit  
	- 论文 Voice Activity Detection Using an Adaptive Context Attention Model 的开源实现，此外还包含作者团队自行录制的语音数据集。
	- https://github.com/jtkim-kaist/VAD  
* Knowledge Graph Representation  
	- 用PyTorch实现知识图谱表示
	- https://github.com/jimmywang heng/knowledge_representation_pytorch
* PyHanLP  
	- 汉语言处理包 HanLP 的 Python 接口，支持自动下载与升级 HanLP，兼容 py2 和 py3
	- https://github.com/hankcs/pyhanlp
	- http://www.hankcs.com/nlp/ hanlp.html
* Knowledge Graph Representation  
	- 用PyTorch实现知识图谱表示
	- https://github.com/jimmywangheng/knowledge_representation_pytorch

## 2. [2018年最流行的机器学习开源项目](./hot_2018.md)

## 3. GAN 开源项目
1. GANDissect [[2]](https://mp.weixin.qq.com/s/OmSb1dl9smyZt_uASOcofQ)  
    只要鼠标划过，GAN 就可以立即在你指定的地方画出云彩、草地、门和树等景物，并直接改变构图以保持图像的合理性
    + 项目地址: [https://github.com/CSAILVision/GANDissect](https://github.com/CSAILVision/GANDissect)
    + 工具链接: [http://gandissect.res.ibm.com/ganpaint.html?project=churchoutdoor&layer=layer4](http://gandissect.res.ibm.com/ganpaint.html?project=churchoutdoor&layer=layer4)
    + 论文地址 : [https://arxiv.org/pdf/1811.10597.pdf](https://arxiv.org/pdf/1811.10597.pdf)

2. 一键拯救发际线 [[4]](https://mp.weixin.qq.com/s/cBTnX1lNHJhCMDX926aujA)  
    + GitHub地址 : https://github.com/SummitKwan/transparent_latent_gan

    + Demo地址 : https://www.kaggle.com/summitkwan/tl-gan-demo
    + 模型博客文章地址 : https://blog.insightdatascience.com/generating-custom-photo-realistic-faces-using-ai-d170b1b59255
    + 模型的PPT地址 : https://docs.google.com/presentation/d/1OpcYLBVpUF1L-wwPHu_CyKjXqXD0oRwBoGP2peSCrSA/edit#slide=id.p1

## 4. 机器学习开源项目 [[3]](https://mp.weixin.qq.com/s/VjszE7xP5QSjzChn8wZDLw)
1. FastText  
用于快速文本表示和分类的库。基于FastText的一款名为Muse的多语种无监督或有监督的词嵌入  
    + 来自 Facebook Research。
    + 链接: https://goo.gl/VWGfCs
    
1. Deep-photo-styletransfer
论文 “深度照片风格转换”的代码与数据。
    + 来自Fujun Luan博士，康奈尔大学。
    + 链接 : https://github.com/luanfujun/deep-photo-styletransfer?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. 面部识别API   
全世界最简单的面部识别API，基于Python与命令行。
    + 来自Adam Geitgey。
    + 链接 : https://github.com/ageitgey/face_recognition?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. Magenta   
通过机器智能生成的音乐和艺术
    + 链接 : https://github.com/tensorflow/magenta?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. Sonnet   
基于TensorFlow的神经网络库
    + 来自Malcolm Reynolds，Deepmind.
    + 链接 : https://github.com/deepmind/sonnet?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. TensorFlow.js   
用于网络的硬件加速机器智能库
    + 来自Nikhil Thorat，Google Brain
    + 链接 : https://github.com/PAIR-code/deeplearnjs?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. 快速风格转移   
基于TensorFlow的快速风格转移  
    + 来自Logan Engstrom，MIT
    + 链接 : https://github.com/lengstrom/fast-style-transfer?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. Pysc2
星际争霸II学习环境   
    + 来自Timo Ewalds，Deepmind
    + 链接 : https://github.com/deepmind/pysc2?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. AirSim   
基于虚幻引擎的开源模拟器，适用于Microsoft AI和Research的自动驾驶交通工具
    + 来自Shital Shah，Microsoft
    + 链接 : https://github.com/Microsoft/AirSim?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1.  Facets   
机器学习数据集的可视化
    + 来自Google Brain
    + 链接 : https://github.com/PAIR-code/facets?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. Style2Paints   
AI图像着色
    + 链接 : https://github.com/lllyasviel/style2paints?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. Tensor2Tensor   
广义序列模型及序列模型的库
    + 来自Ryan Sepassi，Google Brain
    + 链接 : https://github.com/tensorflow/tensor2tensor?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. PyTorch图像转换   
PyTorch图像转换（例如horse2zebra，edges2cats等）
    + 来自朱俊彦博士，加州大学伯克利分校。
    + 链接 : https://github.com/junyanz/pytorch-CycleGAN-and-pix2pix?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. Faiss   
用于高效相似性搜索和密集向量聚类的库
    + 来自Facebook Research
    + 链接 : https://github.com/facebookresearch/faiss?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. Fashion-mnist   
一个类似MNIST的时尚产品数据库
    + 来自Han Xiao，Zalando Tech科研学者
    + 链接 : https://github.com/zalandoresearch/fashion-mnist?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. ParlAI   
在各种公开可用的对话数据集上训练并评估AI模型的框架
    + 来自Alexander Miller，Google Research
    + 链接 : https://github.com/facebookresearch/ParlAI?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more


1. Fairseq   
序列到序列工具包
    + 来自Facebook AI Research
    + 链接 : https://github.com/facebookresearch/fairseq?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. Pyro   
使用Python和PyTorch进行深度通用概率编程
    + 来自Uber AI Labs
    + 链接 : https://github.com/uber/pyro?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. iGAN   
基于GAN的交互式图像生成
    + 链接 : https://github.com/junyanz/iGAN?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. Deep-image-prior   
不基于学习的神经网络图像恢复
    + 来自Dmitry Ulyanov博士，Skoltech
    + 链接 : https://github.com/DmitryUlyanov/deep-image-prior?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. Face_classification   
基于keras CNN模型和openCV、使用fer20
1. / imdb数据集进行实时人脸检测和情感/性别分类。
    + 链接 : https://github.com/oarriaga/face_classification?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. Speech-to-Text-WaveNet   
使用DeepMind的WaveNet和tensorflow的端到端句子级英语语音识别
    + 来自Namju Kim，Kakao Brain
    + 链接 : https://github.com/buriburisuri/speech-to-text-wavenet?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. StarGAN   
用于多域图像转换的统一生成式对抗网络
    + 来自Yunjey Choi，Korea University
    + 链接 : https://github.com/yunjey/StarGAN?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. Ml-agents   
Unity机器学习智能体
    + 来自Arthur Juliani，Unity3D Deep Learning
    + 链接 : https://github.com/Unity-Technologies/ml-agents?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. DeepVideoAnalytics   
分布式视觉搜索和可视化数据分析平台
    + 链接 : https://github.com/AKSHAYUBHAT/DeepVideoAnalytics/?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. OpenNMT   
基于Torch的开源神经机器翻译
    + 链接 : https://github.com/OpenNMT/OpenNMT?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. Pix2pixHD   
使用条件GAN合成并处理2048x
1.24图像
    + 来自AI研究科学家Ming-Yu Liu，Nvidia
    + 链接 : https://github.com/NVIDIA/pix2pixHD?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. Horovod   
TensorFlow的分布式培训框架
    + 来自Uber Engineering
    + 链接 : https://github.com/uber/horovod?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. AI-Block   
一个功能强大且直观的WYSIWYG界面，允许任何人创建机器学习模型
    + 链接 : https://github.com/MrNothing/AI-Blocks?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more

1. Speaking like Kate Winslet   
基于Tensorflow的语音转换（语音样式传输）深度神经网络
    + 来自Dabi Ahn，Kakao Brain AI Research
    + 链接 : https://github.com/andabi/deep-voice-conversion?utm_source=mybridge&utm_medium=blog&utm_campaign=read_more


## 5. 一站式AI平台

1. [百度飞桨](https://aistudio.baidu.com)

# 参考
1. 9个机器学习开源项目 . https://blog.csdn.net/tMb8Z9Vdm66wH68VX1/article/details/79765391
2. 人人都是画家 : 朱俊彦&周博磊等人的GAN画笔帮你开启艺术生涯 . https://mp.weixin.qq.com/s/OmSb1dl9smyZt_uASOcofQ
3. 30个超赞的机器学习开源项目 . https://mp.weixin.qq.com/s/VjszE7xP5QSjzChn8wZDLw
4. 想怎么GAN就怎么GAN，一键拯救发际线 . https://mp.weixin.qq.com/s/cBTnX1lNHJhCMDX926aujA  


----------
[`@RunAtWorld的csdn`](https://blog.csdn.net/RunAtWorld)    [`@RunAtWorld的github`](https://github.com/RunAtWorld)

